/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.modular.bi.pigchildbirth.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.modular.bi.pigchildbirth.entity.PigChildbirth;
import vip.xiaonuo.modular.bi.pigchildbirth.mapper.PigChildbirthMapper;
import vip.xiaonuo.modular.bi.pigchildbirth.param.PigChildbirthAddParam;
import vip.xiaonuo.modular.bi.pigchildbirth.param.PigChildbirthEditParam;
import vip.xiaonuo.modular.bi.pigchildbirth.param.PigChildbirthIdParam;
import vip.xiaonuo.modular.bi.pigchildbirth.param.PigChildbirthPageParam;
import vip.xiaonuo.modular.bi.pigchildbirth.service.PigChildbirthService;

import java.util.List;

/**
 * 母猪妊娠Service接口实现类
 *
 * @author wang
 * @date  2023/12/07 09:39
 **/
@Service
public class PigChildbirthServiceImpl extends ServiceImpl<PigChildbirthMapper, PigChildbirth> implements PigChildbirthService {

    @Override
    public Page<PigChildbirth> page(PigChildbirthPageParam pigChildbirthPageParam) {
        QueryWrapper<PigChildbirth> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(pigChildbirthPageParam.getEartag())) {
            queryWrapper.lambda().like(PigChildbirth::getEartag, pigChildbirthPageParam.getEartag());
        }
        if(ObjectUtil.isNotEmpty(pigChildbirthPageParam.getStartBirthDate()) && ObjectUtil.isNotEmpty(pigChildbirthPageParam.getEndBirthDate())) {
            queryWrapper.lambda().between(PigChildbirth::getBirthDate, pigChildbirthPageParam.getStartBirthDate(), pigChildbirthPageParam.getEndBirthDate());
        }
        if(ObjectUtil.isAllNotEmpty(pigChildbirthPageParam.getSortField(), pigChildbirthPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(pigChildbirthPageParam.getSortOrder());
            queryWrapper.orderBy(true, pigChildbirthPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(pigChildbirthPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(PigChildbirth::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(PigChildbirthAddParam pigChildbirthAddParam) {
        PigChildbirth pigChildbirth = BeanUtil.toBean(pigChildbirthAddParam, PigChildbirth.class);
        this.save(pigChildbirth);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(PigChildbirthEditParam pigChildbirthEditParam) {
        PigChildbirth pigChildbirth = this.queryEntity(pigChildbirthEditParam.getId());
        BeanUtil.copyProperties(pigChildbirthEditParam, pigChildbirth);
        this.updateById(pigChildbirth);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<PigChildbirthIdParam> pigChildbirthIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(pigChildbirthIdParamList, PigChildbirthIdParam::getId));
    }

    @Override
    public PigChildbirth detail(PigChildbirthIdParam pigChildbirthIdParam) {
        return this.queryEntity(pigChildbirthIdParam.getId());
    }

    @Override
    public PigChildbirth queryEntity(Integer id) {
        PigChildbirth pigChildbirth = this.getById(id);
        if(ObjectUtil.isEmpty(pigChildbirth)) {
            throw new CommonException("母猪妊娠不存在，id值为：{}", id);
        }
        return pigChildbirth;
    }
}
